OPENQASM 2.0;
include "qelib1.inc";

// Initialize Quantum and Classical Registers
qreg q[7];
creg c[2];

// Generate All Combinations
h q[0];
h q[1];
h q[2];
h q[3];

//// ITERATION 1
// Constraints (to tag optimal solution)
x q[4];
x q[5];
cx q[0],q[1];
cx q[2],q[3];
x q[0];
x q[1];
x q[3];
x q[1];
x q[3];
ccx q[1],q[3],q[4];
x q[1];
x q[2];
x q[3];
ccx q[0],q[2],q[5];
x q[0];
x q[2];
ccx q[4],q[5],q[6];
x q[0];
x q[2];
z q[6];
ccx q[4],q[5],q[6];
ccx q[0],q[2],q[5];
x q[0];
x q[1];
x q[2];
x q[3];
x q[5];
ccx q[1],q[3],q[4];
id q[5];
x q[1];
x q[3];
x q[4];
id q[5];
x q[1];
x q[3];
id q[4];
id q[5];
cx q[0],q[1];
cx q[2],q[3];
id q[4];
id q[5];

// Canceling Circuit
h q[0];
h q[1];
h q[2];
h q[3];
x q[4];
x q[5];
x q[0];
x q[1];
x q[2];
x q[3];
cx q[0],q[1];
cx q[2],q[3];
x q[0];
x q[1];
x q[3];
x q[1];
x q[3];
ccx q[1],q[3],q[4];
x q[1];
x q[2];
x q[3];
ccx q[0],q[2],q[5];
x q[0];
x q[2];
ccx q[4],q[5],q[6];
x q[0];
x q[2];
z q[6];
ccx q[4],q[5],q[6];
ccx q[0],q[2],q[5];
id q[6];
x q[0];
x q[1];
x q[2];
x q[3];
x q[5];
id q[6];
ccx q[1],q[3],q[4];
id q[5];
id q[6];
x q[1];
x q[3];
x q[4];
id q[5];
id q[6];
x q[1];
x q[3];
id q[5];
id q[6];
cx q[0],q[1];
cx q[2],q[3];
id q[6];
x q[0];
x q[1];
x q[2];
x q[3];
h q[0];
h q[1];
h q[2];
h q[3];
// End of Canceling Circuit
//// END OF ITERATION 1

//// ITERATION 2
// Tagging Circuit for Iteration 2
x q[4];
x q[5];
cx q[0],q[1];
cx q[2],q[3];
x q[0];
x q[1];
x q[3];
x q[1];
x q[3];
ccx q[1],q[3],q[4];
x q[1];
x q[2];
x q[3];
ccx q[0],q[2],q[5];
x q[0];
x q[2];
ccx q[4],q[5],q[6];
x q[0];
x q[2];
z q[6];
ccx q[4],q[5],q[6];
ccx q[0],q[2],q[5];
x q[0];
x q[1];
x q[2];
x q[3];
x q[5];
ccx q[1],q[3],q[4];
id q[5];
x q[1];
x q[3];
x q[4];
id q[5];
x q[1];
x q[3];
id q[4];
id q[5];
cx q[0],q[1];
cx q[2],q[3];
id q[4];
id q[5];
// End of Tagging Circuit for Iteration 2

// Canceling Circuit for Iteration 2
h q[0];
h q[1];
h q[2];
h q[3];
x q[4];
x q[5];
x q[0];
x q[1];
x q[2];
x q[3];
cx q[0],q[1];
cx q[2],q[3];
x q[0];
x q[1];
x q[3];
x q[1];
x q[3];
ccx q[1],q[3],q[4];
x q[1];
x q[2];
x q[3];
ccx q[0],q[2],q[5];
x q[0];
x q[2];
ccx q[4],q[5],q[6];
x q[0];
x q[2];
z q[6];
ccx q[4],q[5],q[6];
ccx q[0],q[2],q[5];
id q[6];
x q[0];
x q[1];
x q[2];
x q[3];
x q[5];
id q[6];
ccx q[1],q[3],q[4];
id q[5];
id q[6];
x q[1];
x q[3];
x q[4];
id q[5];
id q[6];
x q[1];
x q[3];
id q[5];
id q[6];
cx q[0],q[1];
cx q[2],q[3];
id q[6];
x q[0];
x q[1];
x q[2];
x q[3];
h q[0];
h q[1];
h q[2];
h q[3];
// End of Canceling Circuit for Iteration 2
//// END OF ITERATION 2

// Collapse Qubits
measure q[0] -> c[0];
measure q[2] -> c[1];