#!/usr/bin/env python
# coding: utf-8

# Import Cirq libraries
import cirq
from cirq.ops import H, X

# Declare the qubits - place diagonally: q[0] at (0,0), q[1] at (1,1)
q = [cirq.GridQubit(i, i) for i in range(2)] 

# Set up Circuit
circuit = cirq.Circuit()
circuit.append([X(q[1]),H(q[0]), H(q[1]), X(q[1]), H(q[0])])
circuit.append(cirq.measure(q[0], key='m'))

print(circuit)

# Get a simulator to execute the circuit
simulator = cirq.Simulator()
# Simulate the circuit several times
result = simulator.run(circuit, repetitions=1) 
# Print the results
print("Results:")
print(result)




