#!/usr/bin/env python
# coding: utf-8
import numpy as np
import math
from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer)
from qiskit.visualization import plot_histogram
from qiskit.quantum_info.operators import Operator 


U_F =  Operator([ 
    [1,0,0,0,0,0,0,0],
    [0,0,0,0,0,1,0,0],
    [0,0,1,0,0,0,0,0],
    [0,0,0,0,0,0,0,1],
    [0,0,0,0,1,0,0,0],
    [0,1,0,0,0,0,0,0],
    [0,0,0,0,0,0,1,0],
    [0,0,0,1,0,0,0,0] 
]) 


# Check unitary
print('Operatator is unitary:', U_F.is_unitary())

circuit = QuantumCircuit(3,2) 
circuit.x(2)
circuit.h(range(3))
circuit.append(U_F,[0,1,2]) 
circuit.h(range(2))
circuit.measure([0,1],[0,1]) 

circuit.draw(output='mpl')

# Use simulator to run the circuit
backend = Aer.get_backend('qasm_simulator') 
# Define the run parameters and execute
job = execute( circuit, backend, shots=1 ) 
# Tally the results
collapsed_states_array = job.result().get_counts() 
print(collapsed_states_array)



