OPENQASM 2.0;
include "qelib1.inc";
// Initialized Quantum and Classical Registers
qreg q[7];
creg c[4];

// Generate All 2^4=16 Combinations
h q[0];
h q[1];
h q[2];
h q[3];

//// ITERATION 1 
// Tag |1011> 
x q[1]; // X Gate on |x_1> to tag |1011> 
ccx q[0],q[1],q[4];
ccx q[2],q[4],q[5];
ccx q[3],q[5],q[6];
z q[6];
ccx q[3],q[5],q[6];
ccx q[2],q[4],q[5];
ccx q[0],q[1],q[4];
x q[1];

// Canceling Circuit
h q[0];
h q[1];
h q[2];
h q[3];
x q[0];
x q[2];
x q[3];
x q[1];
ccx q[0],q[1],q[4];
ccx q[2],q[4],q[5];
ccx q[3],q[5],q[6];
z q[6];
ccx q[3],q[5],q[6];
ccx q[2],q[4],q[5];
ccx q[0],q[1],q[4];
x q[0];
x q[1];
x q[2];
x q[3];
h q[0];
h q[1];
h q[2];
h q[3];

//// ITERATION 2
// Tagging Circuit
x q[1];
ccx q[0],q[1],q[4];
ccx q[2],q[4],q[5];
ccx q[3],q[5],q[6];
z q[6];
ccx q[3],q[5],q[6];
ccx q[2],q[4],q[5];
ccx q[0],q[1],q[4];
x q[1];

// Canceling Circuit
h q[0];
h q[1];
h q[2];
h q[3];
x q[1];
x q[2];
x q[3];
x q[0];
ccx q[0],q[1],q[4];
ccx q[2],q[4],q[5];
ccx q[3],q[5],q[6];
z q[6];
ccx q[3],q[5],q[6];
ccx q[2],q[4],q[5];
ccx q[0],q[1],q[4];
x q[0];
x q[1];
x q[2];
x q[3];
h q[0];
h q[1];
h q[2];
h q[3];

// Collapse Qubits
measure q[0] -> c[0];
measure q[1] -> c[1];
measure q[2] -> c[2];
measure q[3] -> c[3];
