#!/usr/bin/env python
# coding: utf-8

import numpy as np # (1)
import math
from qiskit import(
QuantumCircuit, 
QuantumRegister,
ClassicalRegister,
execute,
Aer)
from qiskit.visualization import plot_histogram

circuit = QuantumCircuit() # (2)

q = QuantumRegister(1,'qreg') # (3)
circuit.add_register( q )

c = ClassicalRegister(1,'creg') # (4)
circuit.add_register(c)

circuit.measure(0,0) # (5)

circuit.draw(output='mpl') # (6)

backend = Aer.get_backend('qasm_simulator') # (7)

job = execute( circuit, backend, shots=1024 ) # (8)

hist = job.result().get_counts() # (9)
plot_histogram( hist )

