#!/usr/bin/env python
# coding: utf-8


import numpy as np
import math
from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer)
from qiskit.visualization import plot_histogram
Import Qiskt, math, NumPy libraries

# Define the input quantum state
input_quantum_state = [0,
                       math.sqrt(3)/2*complex(1,0),
                      0, 
                      1/2 * complex(1,0)]

# Initialize circuit
q = QuantumRegister(2) 
c = ClassicalRegister(2)
circuit = QuantumCircuit(q,c) 
circuit.initialize(input_quantum_state, q) 
#circuit.draw(output='mpl')

backend = Aer.get_backend('statevector_simulator')
job = execute(circuit, backend)
result = job.result()
statevector = result.get_statevector(decimals=3)
print(statevector)


# Add Measure Gates
circuit.measure(q,c)

backend = Aer.get_backend('qasm_simulator')

# Define the run parameters and execute
job = execute( circuit, backend, shots=1024 )

# Tally the results
collapsed_states_array = job.result().get_counts()
print(collapsed_states_array)


