#!/usr/bin/env python
# coding: utf-8

import numpy as np
import math
from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer)
from qiskit.visualization import plot_histogram
from qiskit.quantum_info.operators import Operator

my_gate = Operator([[math.sqrt(3)/2, 1/2*complex(0,1)], [1/2, -math.sqrt(3)/2*complex(0,1)]])
# Check unitary
print('Operatator is unitary:', my_gate.is_unitary())

my_gate
my_gate_2 = Operator([
    [math.sqrt(3)/2, 0, 1/2, 0],
    [0, math.sqrt(3)/2, 0, 1/2],
    [1/2*complex(0,1), 0, -math.sqrt(3)/2*complex(0,1),0],
    [0,1/2*complex(0,1),0, -math.sqrt(3)/2*complex(0,1)]
])
# Check unitary
print('Operatator is unitary:', my_gate_2.is_unitary())

circuit = QuantumCircuit(2, 2)
circuit.append(my_gate_2, [0,1])
circuit.measure([0,1], [0,1])

circuit.draw(output='mpl')

backend = Aer.get_backend('qasm_simulator')

# Define the run parameters and execute
job = execute( circuit, backend, shots=1024 )

# Tally the results
collapsed_states_array = job.result().get_counts()
print(collapsed_states_array)



