#!/usr/bin/env python
# coding: utf-8
# import Qiskit and other libraries
import numpy as np
import math
from qiskit import(
QuantumCircuit,
QuantumRegister,
ClassicalRegister,
execute,
Aer)
from qiskit.visualization import plot_histogram

# Set up circuit with 2 qubits and 1 classical register
circuit = QuantumCircuit(2,1)
circuit.x(1) 
circuit.h(range(2))
circuit.x(1)
circuit.h(0)
circuit.measure(0,0) # Measure gate on top qubit
circuit.draw(output='mpl')

# Get Backend and run circuit 
backend = Aer.get_backend('qasm_simulator')
job = execute( circuit, backend, shots=1 ) 

# plot results
hist = job.result().get_counts()
plot_histogram( hist )


