#!/usr/bin/env python
# coding: utf-8

import numpy as np
from qiskit import(
QuantumCircuit,
execute,
Aer)
from qiskit.visualization import plot_histogram

or_gate_circuit = QuantumCircuit(3, name=' OR ') 
or_gate_circuit.x(range(3))  
or_gate_circuit.ccx(0,1,2) 
or_gate_circuit.x(range(2)) 
or_gate = or_gate_circuit.to_instruction() 

# or_gate_circuit.draw(output='mpl')

main_circuit = QuantumCircuit(4,3) 
main_circuit.x(1) 
main_circuit.append(or_gate, [0,1,3]) 
main_circuit.measure([0,1,3],[0,1,2]) 

# circuit.draw(output='mpl')


backend = Aer.get_backend('qasm_simulator') 
job = execute( main_circuit, backend, shots=1024 )
# Tally the results
hist = job.result().get_counts()
# Plot the histogram of quantum states
plot_histogram( hist )

decomposed_circuit = main_circuit.decompose() 
#decomposed_circuit.draw(output='mpl')

